	list      p=18f4550            ; list directive to define processor
	#include <p18f4550.inc>        ; processor specific variable definitions

	extern buf_init, buf_read, buf_write

bank0 udata
rs232_ptr res 2

GPS_CODE	CODE

;Procedure for initialization of the serial port
ser_init:
	global ser_init
	;Initialize the pointer to the buffer
	banksel rs232_ptr
	movlw 0x03
	movwf rs232_ptr+1
	movlw 0x00
	movwf rs232_ptr
	; Serial port requires that TRISC b7=b6=1
	;movlw b'11111111'
	;movwf TRISC,ACCESS
;To set up an Asynchronous Reception:
;Initialize the SPBRGH:SPBRG registers for the
;    appropriate baud rate. Set or clear the BRGH
;    and BRG16 bits, as required, to achieve the
;    desired baud rate.
	; BAUDGEN for 48MHz OSC and 9600 baud
	; 48E6/4/9600-1=1249
	movlw low(d'1249')
	movwf SPBRG,ACCESS
	movlw high(d'1249')
	movwf SPBRGH,ACCESS
; Enable the asynchronous serial port by clearing
;    bit SYNC and setting bit SPEN.
; Set the TXSTA
; b2(BRGH)=1
; b5(TXEN)=1 - well, I just try to get the whole thing working!!!
	movlw b'00000100'
	movwf TXSTA,ACCESS
	movlw b'10000000'
	movwf RCSTA,ACCESS
; If the signal at the RX pin is to be inverted, set
;    the RXDTP bit.
	movlw b'00001000'
	movwf BAUDCON,ACCESS
; If interrupts are desired, set enable bit RCIE.
	movf RCREG,W,ACCESS
	movf RCREG,W,ACCESS
	bcf PIR1,RCIF,ACCESS
	bsf PIE1,RCIE,ACCESS ; Temporarly disabled
	bsf IPR1,RCIP,ACCESS ; bsf - didn't help either...
; Enable the reception by setting bit CREN.
	movf RCREG,W,ACCESS
	movf RCREG,W,ACCESS
	bsf RCSTA,CREN,ACCESS
	movf RCREG,W,ACCESS
	movf RCREG,W,ACCESS
	return

ser_rx_irq:
	global ser_rx_irq
; Flag bit, RCIF, will be set when reception is
;    complete and an interrupt will be generated if
;    enable bit, RCIE, was set.
	btfss PIR1,RCIF,ACCESS
	return
; Read the RCSTA register to get the 9th bit (if
;    enabled) and determine if any error occurred
;    during reception.
	movf RCSTA,W,ACCESS
; If eny error occured, clear and srt again the CREN register
	btfsc RCSTA,OERR,ACCESS
	bra reenable_rx
; Read the 8-bit received data by reading the
;    RCREG register.
	movf RCREG,W,ACCESS
	call buf_write
	banksel rs232_ptr
	incf rs232_ptr,F,ACCESS
; If any error occurred, clear the error by clearing
;    enable bit CREN.
; If using interrupts, ensure that the GIE and PEIE
;    bits in the INTCON register (INTCON<7:6>) are
;    set.
	return
reenable_rx:
	movf RCREG,W,ACCESS
	call buf_write
	bcf RCSTA,CREN,ACCESS
	bsf RCSTA,CREN,ACCESS
	return
	END
