	list      p=18f4550            ; list directive to define processor
	#include <p18f4550.inc>        ; processor specific variable definitions
	#include "bit_bang_spi/mspi.inc"
	#include "bit_bang_spi/mspi_ext.inc"
bank0 udata
sd_card_flags res 1
SDC_FLAG_V2 equ 7
SDC_FLAG_CCS equ 6
sd_counter res 2
sd_counter2 res 1
sd_delay res 2
sd_address res 4
sd_max_block res 4
sd_csd res 0x10
sd_tmp res 4
sd_test_block res 4
sd_byte_cnt res 2
disp_tmp res 1
   global sd_address
	global sd_test_block
   extern lcd_row_0
	extern lcd_row_1
	extern DEL_N_MS
SD_CODE	CODE

long_delay:
	global long_delay
	banksel sd_counter
	clrf sd_counter,BANKED
long_delay_1:
	call delay_1ms
	banksel sd_counter
	decfsz sd_counter,F,BANKED
	goto long_delay_1
	return

delay_1ms:
	banksel sd_delay
	movlw low(30000)
	movwf sd_delay,BANKED
	movlw high(30000)
	movwf sd_delay+1,BANKED
delay_1ms_1:
	movlw 1
	subwf sd_delay,F,BANKED
	movlw 0
	subwfb sd_delay+1,F,BANKED
	btfsc STATUS,C,ACCESS
	goto delay_1ms_1
	return

; The procedure sd_wait_data_packet waits until 0xfe is returned
; Currently there is a timeout. But probably we should include 
; the error handling. 
sd_wait_data_packet:
	bsf sdo_port, sdo_pin, ACCESS
	banksel sd_counter
	movlw 0x01
	movwf sd_counter, BANKED
	movlw 0x00
	movwf sd_counter+1, BANKED
sd_wait_data_packet_1:
	call mspi_byte_i
	xorlw 0xfe
	btfsc STATUS,Z,ACCESS
	return
	banksel sd_counter
	incfsz sd_counter+1, F, BANKED
	goto sd_wait_data_packet_1
	incfsz sd_counter,F,BANKED
	goto sd_wait_data_packet_1
	return

; The procedure sd_wait_response waits until the bit with B7=0 is returned
; Waiting for longer than 16 bytes means an error (no card?)
sd_wait_response:
	global sd_wait_response
	banksel sd_counter
	movlw 0x10
	movwf	sd_counter, BANKED	
	bsf sdo_port, sdo_pin, ACCESS
sd_wait_response_1:
	call mspi_byte_i
	btfss WREG,7,ACCESS
	return
	banksel sd_counter
	decfsz sd_counter, F, BANKED
	goto sd_wait_response_1
	retlw 0xff

; The procedure sd_init tries to initialize the SD/MMC card
sd_init:
	global sd_init
	movlw 'I'
	movff WREG,lcd_row_0
	; Clear the byte with the card flags
	banksel sd_card_flags
	clrf sd_card_flags,BANKED
	; First try to wakeup the card
	bsf cs_port, cs_pin, ACCESS
	movlw 0xff
	; We rely on fact that mspi_byte_o doesn't change WREG
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	; Now we send the CMD0 with CS low
	bcf cs_port, cs_pin, ACCESS
	; We send the CMD0 two times, due to some anomalities found 
	; in Toshiba cards
	; First CMD0 - one of my old Toshiba cards responds incorrectly
	; Maybe it responses with R1b response?
	movlw 0xff
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	;movlw 'S'
	;movwf POSTINC2, ACCESS
	;movlw 0x40
	;call mspi_byte_o
	;movlw 0x0
	;call mspi_byte_o
	;call mspi_byte_o
	;call mspi_byte_o
	;call mspi_byte_o
	;movlw 0x95
	;call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	; Second CMD0
	movlw	0x40
	call mspi_byte_o
	movlw 0x0
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw 0x95
	call mspi_byte_o
	; Now we should wait for response
	call sd_wait_response
	btfsc WREG,7,ACCESS
	goto sd_init_error
;	movlw '0'
;	movwf POSTINC1, ACCESS
	; We have received the response
	; Now we should proceed with the card initialization
	; Wait a little before a new command is sent
	movlw 0xff
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	; First assumption: this is a new SD card
	; Send it a CMD8
	movlw 0x48
	call mspi_byte_o
	movlw 0x00
	call mspi_byte_o
	call mspi_byte_o
	movlw 0x01
	call mspi_byte_o
	movlw 0xaa
	call mspi_byte_o
	movlw 0x87 ; CRC7 for CMD8
	call mspi_byte_o
	; Wait for response
	call sd_wait_response
	btfsc WREG,7,ACCESS
	goto sd_init_error
	; Now check if the command was valid
	btfsc WREG,2,ACCESS
	goto sd_init_not_v2
	; If we are here, then we work with the SD V2 card
	; Now we should check if this is the SDHC card
	; read the response
	movlw '2'
	movff WREG,lcd_row_1
	bsf sdo_port, sdo_pin, ACCESS
	call mspi_byte_i ; should be 0
	xorlw 0
	btfss STATUS,Z,ACCESS
	goto sd_init_error_v2_incompatible
	call mspi_byte_i ; should be 0
	xorlw 0
	btfss STATUS,Z,ACCESS
	goto sd_init_error_v2_incompatible
	call mspi_byte_i ; should be 1
	xorlw 1
	btfss STATUS,Z,ACCESS
	goto sd_init_error_v2_incompatible
	call mspi_byte_i ; should be 0xaa
	xorlw 0xaa
	btfss STATUS,Z,ACCESS
	goto sd_init_error_v2_incompatible
	; This a compatible SDCCV2 card
	; We should set the flag informing, that the card is V2
	banksel sd_card_flags
	bsf sd_card_flags,SDC_FLAG_V2,BANKED
	; receive the CRC bytes
	call mspi_byte_i
	call mspi_byte_i
sd_init_not_v2:
	;movlw '1'
	;movwf POSTINC2, ACCESS
	; Now it still possible, that we have either the MMC card or the SD card
	; First we should read the OCR register
sd_init_read_ocr:	
	movlw 0x7a ; CMD58
	call mspi_byte_o
	movlw 0x0
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	goto sd_init_error
	btfsc WREG,2,ACCESS
	goto sd_init_error ; The card should support read_OCR
	; Now we can read the 4 OCR bytes
	bsf sdo_port, sdo_pin, ACCESS
	call mspi_byte_i ; bits 31-24 of OCR
	call mspi_byte_i ; bits 23-16 of OCR
	; This bit should be set to ones
	xorlw 0xff
	btfss STATUS,Z,ACCESS
	goto sd_init_error
	call mspi_byte_i ; bits 15-8 of OCR
	call mspi_byte_i ; bits 7-0 of OCR
	; Next we issue an ACMD41 command
	movlw 0xff
	call mspi_byte_o ; BTW we read the CRC
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
sd_init_retry:
	global sd_init_retry
	banksel sd_counter2
	movlw 0xc0
	movwf sd_counter2, BANKED
sd_init_acmd41:
	;movlw '4'
	;movwf POSTINC2, ACCESS
;sd_init_acmd41:
	; The Toshiba Card required some delay between sending
	; CMD55 and CMD41 commands! Otherwise it returned
	; the invalid command response
	movlw 0xff
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw	0x77 ; CMD55
	call mspi_byte_o
	movlw 0x0
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	goto sd_init_error
	btfsc WREG,2,ACCESS
	goto sd_init_mmc ; This is an MMC card
	;movlw '5'
	;movwf POSTINC2, ACCESS
	; The Toshiba Card required some delay between sending
	; CMD55 and CMD41 commands! Otherwise it returned
	; the invalid command response
	movlw 0xff
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw	0x69 ; CMD41
	call mspi_byte_o
	movlw 0x0
	; Now we have to decide if we should set the HCS bit
	; if the card is the version2 card, then
	; we set the HCS bit
   banksel sd_card_flags
   btfss sd_card_flags,SDC_FLAG_V2, BANKED
   goto sd_init_no_hcs
   movlw 0x40 ; HCS is the sixth bit	
sd_init_no_hcs:	
	call mspi_byte_o
	movlw 0x0
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	goto sd_init_error
	btfsc WREG,2,ACCESS
	goto sd_init_mmc ; This is an MMC card
   ;OK. So now we can be sure, that we have a SD V1 card
	;However, we should check, if the card has already left
	;the idle mode
	btfss WREG,0,ACCESS
	; Now the card is initialized, we can read the associated information
		goto  sd_init_check_ccs
	; Delay by 1 ms
	movlw 0x20
	call DEL_N_MS
	banksel sd_counter2
	decfsz sd_counter2,F,BANKED
		goto  sd_init_acmd41
	;movlw 'X'
	;movwf POSTINC2, ACCESS
	goto sd_init_error
sd_init_check_ccs:
   ; Here we check the CCS flag if we have the V2 card
   banksel sd_card_flags
   btfss sd_card_flags,SDC_FLAG_V2,BANKED
   goto sd_init_read_info
   ; We have to send CMD58 once again
   movlw 0x7a ; CMD58
	call mspi_byte_o
	movlw 0x0
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	goto sd_init_error
	btfsc WREG,2,ACCESS
	goto sd_init_error ; The card should support read_OCR
	; Now we can read the 4 OCR bytes
	bsf sdo_port, sdo_pin, ACCESS
	call mspi_byte_i ; bits 31-24 of OCR
	; Check if the CCS bit is set
	banksel sd_card_flags
	btfsc WREG,6,ACCESS ; 30th bith of OCR is in 30-24=6th bit of WREG
	bsf sd_card_flags,SDC_FLAG_CCS,BANKED
	call mspi_byte_i ; bits 23-16 of OCR
	; This bit should be set to ones
	xorlw 0xff
	btfss STATUS,Z,ACCESS
	goto sd_init_error
	call mspi_byte_i ; bits 15-8 of OCR
	call mspi_byte_i ; bits 7-0 of OCR
	movlw 0xff
	call mspi_byte_o ; BTW we read the CRC
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
   goto sd_init_read_info
sd_init_mmc:
	;movlw 'M'
	;movwf POSTINC2, ACCESS
	banksel sd_counter2
	movlw 0xc0
	movwf sd_counter2, BANKED
sd_init_mmc_1:
	; Initialization of an MMC card
	movlw	0x41 ; CMD1
	call mspi_byte_o
	movlw 0x0
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	goto sd_init_error
	;However, we should check, if the card has already left
	;the idle mode
	btfss WREG,0,ACCESS
		goto  sd_init_read_info
	call delay_1ms
	banksel sd_counter2
	decfsz sd_counter2,F,BANKED
		goto  sd_init_mmc_1
;	movlw 'V'
;	movwf POSTINC1, ACCESS
	goto sd_init_error
sd_init_read_info:
	; The Toshiba Card required some delay before sending
	; CMD9 command! Otherwise it returned
	; the invalid command response
	movlw 0xff
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
;	movlw ':'
;	movwf POSTINC1, ACCESS
	movlw	0x49 ; CMD9
	call mspi_byte_o
	movlw 0x0
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	goto sd_init_error
	call sd_wait_data_packet
	; Now we can copy the response to the buffer
	bsf sdo_port, sdo_pin, ACCESS
	lfsr 2,sd_csd
	banksel sd_counter
	movlw 0x10 ; 0x10 bytes of register
	movwf	sd_counter, BANKED
sd_init_read_info_1:
	call mspi_byte_i
	movwf POSTINC2, ACCESS
	decfsz sd_counter, F, BANKED
	goto sd_init_read_info_1
	call mspi_byte_i ; byte CRC
	call mspi_byte_i ; byte CRC
	call sd_max_block
	bcf STATUS,C,ACCESS
	return
; Currently we do not read the CID register
	movlw	0x4a ; CMDa
	call mspi_byte_o
	movlw 0x0
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	goto sd_init_error
	call sd_wait_data_packet
	; Now we can copy the response to the buffer
	bsf sdo_port, sdo_pin, ACCESS
	banksel sd_counter
	movlw 0x12 ; 0x10 bytes of register +2 bytes of CRC
	movwf	sd_counter, BANKED
sd_init_read_info_2:
	call mspi_byte_i
	movwf POSTINC1, ACCESS
	decfsz sd_counter, F, BANKED
	goto sd_init_read_info_2
	return
sd_init_error_v2_incompatible:
	movlw 'i'
	movff WREG,lcd_row_1+1
sd_init_error:
	bsf STATUS,C,ACCESS
	return

; Function sd_read_block reads the particular block from the card
; It uses the address register
sd_read_block:
	global sd_read_block
	; First we have to decide if we need to multiply the block number by 512 
	; (not a HC card)
   banksel sd_card_flags
   btfsc sd_card_flags, SDC_FLAG_CCS, BANKED
   goto sd_read_block_hc
sd_read_block_nohc:
	banksel sd_address
	movlw D'9'
sd_read_block_l1:
	bcf STATUS,C,ACCESS
	rlcf sd_address+3,F,BANKED
	rlcf sd_address+2,F,BANKED
	rlcf sd_address+1,F,BANKED
	rlcf sd_address+0,F,BANKED
	decfsz WREG,F,ACCESS
	goto sd_read_block_l1
sd_read_block_hc:	
	movlw 0x51  ; CMD17
	call mspi_byte_o
	banksel sd_address
	movf sd_address,W,BANKED
	call mspi_byte_o
	movf sd_address+1,W,BANKED
	call mspi_byte_o
	movf sd_address+2,W,BANKED
	call mspi_byte_o
	movf sd_address+3,W,BANKED
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	retlw 0xff ; ERROR
	btfsc WREG,2,ACCESS
	retlw 0xfe ; ERROR
	btfsc WREG,6,ACCESS
	retlw 0xfd ; ERROR
	btfsc WREG,5,ACCESS
	retlw 0xfc ; ERROR
	call sd_wait_data_packet
	; Now transmit 512 bytes
	banksel sd_counter
	clrf sd_counter,BANKED
	bsf sdo_port, sdo_pin, ACCESS
sd_read_block_l2:
		call mspi_byte_i
		movwf POSTINC1, ACCESS
		call mspi_byte_i
		movwf POSTINC1, ACCESS
		decfsz sd_counter,F,BANKED
		goto sd_read_block_l2
	; Read the CRC
	bsf sdo_port, sdo_pin, ACCESS
	call mspi_byte_i
	movwf POSTINC1, ACCESS
	call mspi_byte_i
	movwf POSTINC1, ACCESS
	retlw 0 ; OK	

; Functions responsible for calculation of the maximum block number
sd_calc_max_block:
	global sd_calc_max_block
	banksel sd_max_block
	clrf sd_max_block,BANKED
	clrf sd_max_block+1,BANKED
	clrf sd_max_block+2,BANKED
	clrf sd_max_block+3,BANKED
	;CSD: byte 0 - 127:120, byte 1 - 119:112, byte 2 - 111:104, byte 3 - 103:96
	;		byte 4 - 95:88, byte 5 - 87:80, byte 6 - 79:72, byte 7 - 71:64
	;		byte 8 - 63:56, byte 9 - 55:48, byte 10 - 47:40, byte 11 - 39:32
	;		byte 12 - 31:24, byte 13 - 23:16, byte 14 - 15:8, byte 15 - 7:0
	; Check the version of the CSD
	; bits 127:126 - byte 0, bits 7 and 6
	banksel sd_csd
	btfsc sd_csd,7,BANKED
	goto  sd_calc_max_block_unsupported
	btfsc sd_csd,6,BANKED
	goto	sd_calc_max_block_v2
	; For the card described with CSD1.0
	; CSD_STRUCTURE - bits 127:126 = 0
	; C_SIZE - bits 73:62 - byte
	; C_SIZE_MULT - bits 49:47 
	; READ_BL_LEN - bits 83:80	
	; Capacity in bytes:
	; (C_SIZE+1)*(2^(C_SIZE_MULT+2))*(2^READ_BL_LEN)
	rlcf	sd_csd+D'10',W,BANKED
	rlcf	sd_csd+9,W,BANKED
	andlw 0x07 ; We have C_SIZE_MULT in WREG
	movff WREG,sd_tmp
	banksel sd_csd
	movf  sd_csd+5,W,BANKED
	andlw 0x0f ; We have READ_BL_LEN in WREG
	banksel sd_tmp
	addwf sd_tmp,F,BANKED
	; Now we extract the C_SIZE
	movff sd_csd+6,sd_max_block+1
	movff sd_csd+7,sd_max_block+2
	movff sd_csd+8,sd_max_block+3
	; Mask invalid bits
	banksel sd_max_block
	clrf sd_max_block
	movlw 0x03
	andwf sd_max_block+1,F,BANKED
	movlw 0xc0
	andwf sd_max_block+3,F,BANKED
	; shift by 2 bits
	bcf STATUS,C,ACCESS
	rlcf sd_max_block+3,F,BANKED
	rlcf sd_max_block+2,F,BANKED
	rlcf sd_max_block+1,F,BANKED
	rlcf sd_max_block,F,BANKED
	bcf STATUS,C,ACCESS
	rlcf sd_max_block+3,F,BANKED
	rlcf sd_max_block+2,F,BANKED
	rlcf sd_max_block+1,F,BANKED
	rlcf sd_max_block,F,BANKED
	; shift right by 8 bits
	movff sd_max_block+2,sd_max_block+3
	movff sd_max_block+1,sd_max_block+2
	movff sd_max_block,sd_max_block+1
	clrf sd_max_block	
	; Correct for C_SIZE+1
	movlw 0x01
	addwf sd_max_block+3,F,BANKED
	movlw 0x00
	addwfc sd_max_block+2,F,BANKED
	movlw 0x00
	addwfc sd_max_block+1,F,BANKED
	movlw 0x00
	addwfc sd_max_block+0,F,BANKED
	; Now shifting...
	; The C_SIZE_MULT is increased by 2, but to obtain
	; the number of 512B blocks, we should finally
	; shift right by 9 bits.
	; Therefore we will now increase the shift counter 
	; only by 1, and then shift right by 8, just by
	; transfering of single bytes
	movlw 0x01
	banksel sd_tmp
	addwf sd_tmp,W,BANKED
	; Perform the left shifting
	banksel sd_max_block
sd_calc_mb_loop1:
	bcf STATUS,C,ACCESS
	rlcf sd_max_block+3,F,BANKED
	rlcf sd_max_block+2,F,BANKED
	rlcf sd_max_block+1,F,BANKED
	rlcf sd_max_block,F,BANKED
	decfsz WREG,W,ACCESS
	goto sd_calc_mb_loop1
	; Shift right by 8 bits
	movff sd_max_block+2, sd_max_block+3
	movff sd_max_block+1, sd_max_block+2
	movff sd_max_block, sd_max_block+1
	clrf sd_max_block,BANKED
   goto sd_decrease_max_block
sd_calc_max_block_v2:
	; For the card described with CSD2.0
	; CSD_STRUCTURE - bits 127:126 = 1
	; READ_BL_LEN - bits 83:80	
	; C_SIZE - bits 69:48 (22 bits)
	; Capacity in 512KB blocks: C_SIZE+1
	;
	; C size is located in bytes :  byte 7 - 71:64 byte 8 - 63:56, byte 9 - 55:48
	; however we need to multiply it by 2^10 (512KB block instead of 512B)
	; first we multiply by 2^8 just during copying
	; IMPORTANT! In fact we should mask bits 7&6 of CSD[7], but they will be anyway
	;  removed when we will shift the sd_max_block by two bits to the left
	movff sd_csd+7, sd_max_block
	movff sd_csd+8, sd_max_block+1
	movff sd_csd+9, sd_max_block+2
	banksel sd_max_block
	clrf sd_max_block+3,BANKED
	; Now we increase the C_SIZE by 1 (in fact by 256 as we have already shifted it by 8 bits)
	movlw 0x01
	addwf sd_max_block+2,F,BANKED
	movlw 0x00
	addwfc sd_max_block+1,F,BANKED
	movlw 0x00
	addwfc sd_max_block+0,F,BANKED
	; now we multiply by 4
	bcf STATUS,C,ACCESS
	rlcf sd_max_block+3,F,BANKED
	rlcf sd_max_block+2,F,BANKED
	rlcf sd_max_block+1,F,BANKED
	rlcf sd_max_block,F,BANKED
	bcf STATUS,C,ACCESS
	rlcf sd_max_block+3,F,BANKED
	rlcf sd_max_block+2,F,BANKED
	rlcf sd_max_block+1,F,BANKED
	rlcf sd_max_block,F,BANKED
sd_decrease_max_block:
	; Decrease by 1 to calculate the maximum block number
	movlw 0xff
	addwf sd_max_block+3,F,BANKED
	addwfc sd_max_block+2,F,BANKED
	addwfc sd_max_block+1,F,BANKED
	addwfc sd_max_block,F,BANKED
	; Now we should display the number of the blocks
	lfsr 2, lcd_row_0+8
	movf sd_max_block,W,BANKED
	call disp_hex
	movf sd_max_block+1,W,BANKED
	call disp_hex
	movf sd_max_block+2,W,BANKED
	call disp_hex
	movf sd_max_block+3,W,BANKED
	call disp_hex
	return
	
sd_calc_max_block_unsupported:
	lfsr 2, lcd_row_0+8
	movlw 'E'
	movwf POSTINC2,ACCESS
	movlw 'r'
	movwf POSTINC2,ACCESS
	movlw 'r'
	movwf POSTINC2,ACCESS
	movlw 'o'
	movwf POSTINC2,ACCESS
	movlw 'r'
	movwf POSTINC2,ACCESS

	return

disp_hex
	movff WREG,disp_tmp
	swapf WREG,F,ACCESS
	andlw 0x0f
	; Now we should check if the result is greater, than 0x09
	addlw 0xff-0x09
	btfsc STATUS,C,ACCESS
	addlw 'A'-'0'-0x0a
	addlw '0'+0x0a
	movwf POSTINC2,ACCESS
	movff disp_tmp,WREG
	andlw 0x0f
	; Now we should check if the result is greater, than 0x09
	addlw 0xff-0x09
	btfsc STATUS,C,ACCESS
	addlw 'A'-'0'-0x0a
	addlw '0'+0x0a
	movwf POSTINC2,ACCESS
	return
	
sd_find_free:
	global sd_find_free
	; This procedure finds the first free block in the card.
	; We use the successive approximation algorithm.
	; We start from the maximum block number, and divide it by 2
	; then we check if this block is free.
	;	sd_max_block - number of the last available block
	;	sd_address - number of the block, which is checked
	;	sd_tmp - step
	banksel sd_test_block
	movlw 0x80
	movwf sd_test_block,BANKED	
	clrf sd_test_block+1,BANKED	
	clrf sd_test_block+2,BANKED	
	clrf sd_test_block+3,BANKED	
	; We find the position of the first '1'
	; Copy the maximal block to the sd_tmp
	movff sd_max_block+3,sd_tmp+3
	movff sd_max_block+2,sd_tmp+2
	movff sd_max_block+1,sd_tmp+1
	movff sd_max_block,sd_tmp
sd_find_free_l1:
	bsf STATUS,C,ACCESS
	banksel sd_tmp
	rlcf sd_tmp+3,F,BANKED
	rlcf sd_tmp+2,F,BANKED
	rlcf sd_tmp+1,F,BANKED
	rlcf sd_tmp+0,F,BANKED
	bc sd_find_free_l2
	bcf STATUS,C,ACCESS
	banksel sd_test_block
	rrcf sd_test_block,F,BANKED
	rrcf sd_test_block+1,F,BANKED
	rrcf sd_test_block+2,F,BANKED
	rrcf sd_test_block+3,F,BANKED
	goto sd_find_free_l1
sd_find_free_l2:
	;Now sd_test_block contains the 1 on the same
	;position as the highest 1 in sd_max_block
	;
	;Now we clear the sd_tmp
	banksel sd_tmp
	clrf sd_tmp+3,BANKED
	clrf sd_tmp+2,BANKED
	clrf sd_tmp+1,BANKED
	clrf sd_tmp+0,BANKED
	; We start the successive approximation loop
sd_find_free_sar_loop:
	; First we xor the sd_test_block with the sd_tmp
	banksel sd_tmp
	movff sd_test_block+3,WREG
	xorwf sd_tmp+3,F,BANKED
	movff sd_test_block+2,WREG
	xorwf sd_tmp+2,F,BANKED
	movff sd_test_block+1,WREG
	xorwf sd_tmp+1,F,BANKED
	movff sd_test_block+0,WREG
	xorwf sd_tmp+0,F,BANKED
	;Then we check, if the block number is higher
	;than the maximum: sd_max_block - sd_tmp
	bsf STATUS,C,ACCESS
	banksel sd_max_block
	movff sd_tmp+3,WREG
	subwfb sd_max_block+3,W,BANKED
	movff sd_tmp+2,WREG
	subwfb sd_max_block+2,W,BANKED
	movff sd_tmp+1,WREG
	subwfb sd_max_block+1,W,BANKED
	movff sd_tmp,WREG
	subwfb sd_max_block,W,BANKED
	; There was borrow, so block number is too high
	bnc sd_find_free_cancel_1
	; Now we check if the block is free
	movff sd_tmp+3,sd_address+3
	movff sd_tmp+2,sd_address+2
	movff sd_tmp+1,sd_address+1
	movff sd_tmp+0,sd_address+0
	call sd_check_free
	btfsc WREG,7,ACCESS
	goto sd_find_free_error
	xorlw 0
	bnz sd_find_free_keep_1
sd_find_free_cancel_1:
	banksel sd_tmp
	movff sd_test_block+3,WREG
	xorwf sd_tmp+3,F,BANKED
	movff sd_test_block+2,WREG
	xorwf sd_tmp+2,F,BANKED
	movff sd_test_block+1,WREG
	xorwf sd_tmp+1,F,BANKED
	movff sd_test_block+0,WREG
	xorwf sd_tmp+0,F,BANKED
sd_find_free_keep_1:
	; divide sd_test_block by 2
	banksel sd_test_block
	bcf STATUS,C,BANKED
	rrcf sd_test_block,F,BANKED
	rrcf sd_test_block+1,F,BANKED
	rrcf sd_test_block+2,F,BANKED
	rrcf sd_test_block+3,F,BANKED
	; if it was the last step, then the '1' bit
	; has been shifted out to the carry
	btfss STATUS,C,ACCESS
	goto sd_find_free_sar_loop
	; After the loop has finished, we have the last occupied
	; block, so we have to increase the number by 1 to 
	; obtain the first free block.
	; However there is also a possibility, that the 0th block is also
	; free. In this case we shouldn't increase the number...
	movff sd_tmp+3,sd_address+3
	movff sd_tmp+2,sd_address+2
	movff sd_tmp+1,sd_address+1
	movff sd_tmp+0,sd_address+0
	call sd_check_free
	btfsc WREG,7,ACCESS
	goto sd_find_free_error
	xorlw 0
	bz sd_find_free_dont_incr
	banksel sd_tmp
	incf sd_tmp+3,F,BANKED
	btfsc STATUS,C,ACCESS
	incf sd_tmp+2,F,BANKED
	btfsc STATUS,C,ACCESS
	incf sd_tmp+1,F,BANKED
	btfsc STATUS,C,ACCESS
	incf sd_tmp+0,F,BANKED
sd_find_free_dont_incr
; Finally we should display the number of the first free block
	lfsr 2, lcd_row_1+8
	banksel sd_tmp
	movf sd_tmp,W,BANKED
	call disp_hex
	movf sd_tmp+1,W,BANKED
	call disp_hex
	movf sd_tmp+2,W,BANKED
	call disp_hex
	movf sd_tmp+3,W,BANKED
	call disp_hex
; Move the number of the first free block to the sd_test_block
	movff sd_tmp+3,sd_test_block+3
	movff sd_tmp+2,sd_test_block+2
	movff sd_tmp+1,sd_test_block+1
	movff sd_tmp+0,sd_test_block+0
	return
sd_find_free_error:
	lfsr 2, lcd_row_1+8
	call disp_hex
	movlw 'E'
	movwf POSTINC2,ACCESS
	movlw 'r'
	movwf POSTINC2,ACCESS
	movlw 'r'
	movwf POSTINC2,ACCESS
	return
; Function checking if the block is free
; the block is free if it is all filled with 0xff or 0x00 bytes
sd_check_free:
   ; If the card is not the high capacity card, then
   ; we should multiply the block number by 512 
   ; (shifting it by 9 bits to the left)
   banksel sd_card_flags
   btfsc sd_card_flags, SDC_FLAG_CCS, BANKED
   goto sd_check_free_hc
sd_check_free_nohc:	
	banksel sd_address
	movlw D'9'
sd_check_free_l1:
	bcf STATUS,C,ACCESS
	rlcf sd_address+3,F,BANKED
	rlcf sd_address+2,F,BANKED
	rlcf sd_address+1,F,BANKED
	rlcf sd_address+0,F,BANKED
	decfsz WREG,F,ACCESS
	goto sd_check_free_l1
sd_check_free_hc:	
	movlw 0xff
	; 8 empty words for longer delay between commands
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw 0x40+D'17'  ; CMD17
	call mspi_byte_o
	banksel sd_address
	movf sd_address+0,W,BANKED
	call mspi_byte_o
	movf sd_address+1,W,BANKED
	call mspi_byte_o
	movf sd_address+2,W,BANKED
	call mspi_byte_o
	movf sd_address+3,W,BANKED
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	retlw 0xff ; ERROR
	btfsc WREG,2,ACCESS
	retlw 0xfe ; ERROR
	btfsc WREG,6,ACCESS
	retlw 0xfd ; ERROR
	btfsc WREG,5,ACCESS
	retlw 0xfc ; ERROR
	call sd_wait_data_packet
	; sd_counter2 will be used to record
	; information about the bytes which
	; either not 0x00 or not 0xff
	banksel sd_counter2
	clrf sd_counter2,BANKED
	; Now check 512 bytes
	banksel sd_counter
	clrf sd_counter,BANKED
	bsf sdo_port, sdo_pin, ACCESS
sd_check_block_1:
		banksel sd_counter2
		call mspi_byte_i
		xorlw 0
		btfss STATUS,Z,ACCESS
		bsf sd_counter2,0,BANKED
		xorlw 0xff
		btfss STATUS,Z,ACCESS
		bsf sd_counter2,1,BANKED
		call mspi_byte_i
		xorlw 0
		btfss STATUS,Z,ACCESS
		bsf sd_counter2,0,BANKED
		xorlw 0xff
		btfss STATUS,Z,ACCESS
		bsf sd_counter2,1,BANKED
		banksel sd_counter
		decfsz sd_counter,F,BANKED
		goto sd_check_block_1
	; Read the CRC
	bsf sdo_port, sdo_pin, ACCESS
	call mspi_byte_i
	call mspi_byte_i
	movlw 0xff
	call mspi_byte_o
	call mspi_byte_o
	; Now check the results
	banksel sd_counter2
	movf sd_counter2,W,BANKED
	; if the result is 3, then the block is nonfree
	xorlw 3
	btfsc STATUS,Z,ACCESS
	retlw 0x01 ; Block nonfree 
	retlw 0 ; OK	

; Functions responsible for erasing of the card
sd_erase:
	global sd_erase
	; The starting block is the 0
	movlw 'S'
	movwf POSTINC1,ACCESS
	; send the command cmd32
	movlw 0x40+D'32'  ; CMD32
	call mspi_byte_o
	banksel sd_address
	movlw 0
	call mspi_byte_o
	movlw 0
	call mspi_byte_o
	movlw 0
	call mspi_byte_o
	movlw 0
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	retlw 0xff ; ERROR
	andlw 0x7e
	btfss STATUS,Z,ACCESS
	return ; Any other error
	movlw 'E'
	movwf POSTINC1,ACCESS
		; Calculate the sd_address on the basis of last block number
	movff sd_max_block+3,sd_address+3
	movff sd_max_block+2,sd_address+2
	movff sd_max_block+1,sd_address+1
	movff sd_max_block+0,sd_address+0
	; Convert block number into byte address if not CCS
	banksel sd_card_flags
	btfsc sd_card_flags,SDC_FLAG_CCS,BANKED
	goto sd_erase_v2
	banksel sd_address
	movlw D'9'
sd_erase_l1:
	bcf STATUS,C,ACCESS
	rlcf sd_address+3,F,BANKED
	rlcf sd_address+2,F,BANKED
	rlcf sd_address+1,F,BANKED
	rlcf sd_address+0,F,BANKED
	decfsz WREG,F,ACCESS
	goto sd_erase_l1
sd_erase_v2:	
	movlw 'C'
	movwf POSTINC1,ACCESS
		; send the command cmd33
	movlw 0xff
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw 0x40+D'33'  ; CMD33
	call mspi_byte_o
	banksel sd_address
	movf sd_address+0,W,BANKED
	call mspi_byte_o
	movf sd_address+1,W,BANKED
	call mspi_byte_o
	movf sd_address+2,W,BANKED
	call mspi_byte_o
	movf sd_address+3,W,BANKED
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	retlw 0xff ; ERROR
	andlw 0x7e
	btfss STATUS,Z,ACCESS
	return ; Any other error
	; send the command cmd38
	movlw 0xff
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	call mspi_byte_o
	movlw 0x40+D'38'  ; CMD38
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	; Now we should wait for the response, but it may take a much longer time...
	call sd_wait_response
	btfsc WREG,7,ACCESS
	retlw 0xff ; ERROR
	andlw 0x7e
	btfss STATUS,Z,ACCESS
	return
sd_erase_wait_no_busy:
	bsf sdo_port, sdo_pin, ACCESS
	call mspi_byte_i
	xorlw 0xff
	bnz sd_erase_wait_no_busy
	return
; Function sd_write_block writes the block to the card
; The main problem is: how to assure the device's responsiveness
; during the writing of the data...
; How to assure the proper GUI handling? Should it be event driven?
; The problem is, that we may need to wait for some data to become available...
; Maybe, we should initialize the card in the "Multiple Block Write"
; Therefore we need a few functions...
; 1) sd_write_init - just sends the request to start recording
; 2) sd_write_byte - it may just send a byte to the card, or, if
;    the block is finished, it also waits for the confirmation
; 3) sd_write_stop - this function stops the recording
;			a) it completes the last block (filling it with 0xfe?)
;			b) it stores the last block
;			c) it sends the STOP_TRANSMISSION command
; Function sd_read_block reads the particular block from the card
; It uses the address register
sd_write_init:
	global sd_write_init
	; If this is not a HC card, convert block number into byte address
   banksel sd_card_flags
   btfss sd_card_flags, SDC_FLAG_V2, BANKED
   goto sd_wri_nohc
   btfsc sd_card_flags, SDC_FLAG_CCS, BANKED
   goto sd_wri_hc
sd_wri_nohc:	
	banksel sd_address
	movlw D'9'
sd_wri_l1:
		bcf STATUS,C,ACCESS
		rlcf sd_address+3,F,BANKED
		rlcf sd_address+2,F,BANKED
		rlcf sd_address+1,F,BANKED
		rlcf sd_address+0,F,BANKED
		decfsz WREG,F,ACCESS
		goto sd_wri_l1
sd_wri_hc:
	movlw 0x40+D'25'  ; CMD25
	call mspi_byte_o
	banksel sd_address
	movf sd_address+0,W,BANKED
	call mspi_byte_o
	movf sd_address+1,W,BANKED
	call mspi_byte_o
	movf sd_address+2,W,BANKED
	call mspi_byte_o
	movf sd_address+3,W,BANKED
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	call sd_wait_response
	btfsc WREG,7,ACCESS
	retlw 0xff ; ERROR
	btfsc WREG,2,ACCESS
	retlw 0xfe ; ERROR
	btfsc WREG,6,ACCESS
	retlw 0xfd ; ERROR
	btfsc WREG,5,ACCESS
	retlw 0xfc ; ERROR
	; Send one empty byte before the first token
	movlw 0xff
	call mspi_byte_o
	; Send the data token for the first byte
	movlw 0xfc
	call mspi_byte_o
	; Clear the byte counter
	banksel sd_byte_cnt
	clrf sd_byte_cnt,BANKED
	clrf sd_byte_cnt+1,BANKED
	retlw 0 ; OK

sd_write_byte:
	global sd_write_byte
	; Send the byte
	call mspi_byte_o
	; Now increase and check the byte number
	banksel sd_byte_cnt
	incf sd_byte_cnt,BANKED
	btfsc STATUS,C,ACCESS
	incf sd_byte_cnt+1,BANKED
	; check if it is the 512th byte
	movlw 0x01
	bcf STATUS,C,ACCESS ; clear the C flag before possible return
	cpfsgt sd_byte_cnt+1,BANKED
	retlw 0; counter less then 0x200
	; We have completed the whole block...
	; Clear the byte counter (the proper bank is still selected!!!)
	clrf sd_byte_cnt,BANKED
	clrf sd_byte_cnt+1,BANKED
	; Send the dummy CRC
	movlw 0xff
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	; Now we should receive the data response
	bsf sdo_port, sdo_pin, ACCESS
	call mspi_byte_i
	; Store the data response
	movff WREG,sd_tmp
	; Increase the number of current block
	banksel sd_test_block
	incf sd_test_block+3,F,BANKED
	btfsc STATUS,C,ACCESS
	incf sd_test_block+2,F,BANKED
	btfsc STATUS,C,ACCESS
	incf sd_test_block+1,F,BANKED
	btfsc STATUS,C,ACCESS
	incf sd_test_block+0,F,BANKED
	; Display the new block
	lfsr 2, lcd_row_1+8
	banksel sd_test_block
	movf sd_test_block,W,BANKED
	call disp_hex
	movf sd_test_block+1,W,BANKED
	call disp_hex
	movf sd_test_block+2,W,BANKED
	call disp_hex
	movf sd_test_block+3,W,BANKED
	call disp_hex
	; Wait until the card is not busy
sd_write_byte_1:
	call mspi_byte_i
	xorlw 0xff
	bnz sd_write_byte_1
	; Send the token for the next block
	movlw 0xfc
	call mspi_byte_o
	; Analyse the data response
	movff sd_tmp,WREG
	bcf STATUS,C,ACCESS
	andlw b'00011111'
	xorlw b'00000101'
	btfss STATUS,Z,ACCESS
	bsf STATUS,C,ACCESS
	xorlw b'00000101' ; restore the previous value
	return
	
sd_write_stop:
	global sd_write_stop
	; First complete the last block
sd_write_stop_fill:	
	movlw 0x02
	banksel sd_byte_cnt
	cpfslt sd_byte_cnt+1,BANKED
	goto sd_write_stop_full_block
	movlw 0xff
	call mspi_byte_o
	banksel sd_byte_cnt
	incf sd_byte_cnt,BANKED
	btfsc STATUS,C,ACCESS
	incf sd_byte_cnt+1,BANKED
	goto sd_write_stop_fill
sd_write_stop_full_block:
	; Send the dummy CRC
	movlw 0xff
	call mspi_byte_o
	movlw 0xff
	call mspi_byte_o
	; Now we should receive the data response
	bsf sdo_port, sdo_pin, ACCESS
	call mspi_byte_i
	; Store the data response
	movff WREG,sd_tmp
	; Increase the number of current block
	banksel sd_test_block
	incf sd_test_block+3,F,BANKED
	btfsc STATUS,C,ACCESS
	incf sd_test_block+2,F,BANKED
	btfsc STATUS,C,ACCESS
	incf sd_test_block+1,F,BANKED
	btfsc STATUS,C,ACCESS
	incf sd_test_block+0,F,BANKED
	; Display the new block
	lfsr 2, lcd_row_1+8
	banksel sd_tmp
	movf sd_test_block,W,BANKED
	call disp_hex
	movf sd_test_block+1,W,BANKED
	call disp_hex
	movf sd_test_block+2,W,BANKED
	call disp_hex
	movf sd_test_block+3,W,BANKED
	call disp_hex
	; Wait until the card is not busy
sd_write_stop_1:
	call mspi_byte_i
	xorlw 0xff
	bnz sd_write_stop_1
	; Send the Stop Tran token for CMD25
	movlw 0xfd
	call mspi_byte_o
	; Now we should wait one byte
	; and then wait until card stops to be busy...
	movlw 0xff
	call mspi_byte_o
	; Now we wait until the card exits the busy state
	bsf sdo_port, sdo_pin, ACCESS
sd_write_stop_2:
	call mspi_byte_i
	; Sprawdzamy, czy wynik jest 0xff, jeśli nie, to ponawiamy@@
	xorlw 0xff
	bnz sd_write_stop_2
	; Analyse the data response
	movff sd_tmp,WREG
	bcf STATUS,C,ACCESS
	andlw b'00011111'
	xorlw b'00000101'
	btfss STATUS,Z,ACCESS
	bsf STATUS,C,ACCESS
	xorlw b'00000101' ; restore the previous value
	return
	END
